﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using xNet;
using System.IO;
using Newtonsoft.Json.Linq;
using Newtonsoft.Json;
using System.Threading;
using System.Net;
using Microsoft.Office.Interop.Excel;
using app = Microsoft.Office.Interop.Excel.Application;

namespace ShopeeAPI_v2._0
{
    public partial class Form1 : Form
    {
        public string shopCollection, nameShop, countItem;
        public string[] numbShopCollection = new string[100];
        public string[] nameShopCollection = new string[100];
        public string[] countItemShopCollection = new string[100];
        public int count;
        public double gia;
        public string motaSP, kho, cannang, estimatetime;
        public string[] ship = new string[20];
        public Form1()
        {
            InitializeComponent();
            dataGridView1.Columns[0].HeaderText = "Ngành hàng";
            dataGridView1.Columns[1].HeaderText = "Tên sản phẩm";
            dataGridView1.Columns[2].HeaderText = "Mô tả sản phẩm";
            dataGridView1.Columns[3].HeaderText = "SKU sản phẩm";
            dataGridView1.Columns[4].HeaderText = "Mã sản phẩm";
            dataGridView1.Columns[5].HeaderText = "Tên nhóm phân loại hàng 1";
            dataGridView1.Columns[6].HeaderText = "Tên phân loại hàng cho nhóm phân loại hàng 1";
            dataGridView1.Columns[7].HeaderText = "Hình ảnh mỗi phân loại";
            dataGridView1.Columns[8].HeaderText = "Tên nhóm phân loại hàng 2";
            dataGridView1.Columns[9].HeaderText = "Tên phân loại hàng cho nhóm phân loại hàng 2";
            dataGridView1.Columns[10].HeaderText = "Giá";
            dataGridView1.Columns[11].HeaderText = "Kho";
            dataGridView1.Columns[12].HeaderText = "SKU phân loại";
            dataGridView1.Columns[13].HeaderText = "Ảnh bìa";
            dataGridView1.Columns[14].HeaderText = "Hình ảnh mẫu 1";
            dataGridView1.Columns[15].HeaderText = "Hình ảnh mẫu 2";
            dataGridView1.Columns[16].HeaderText = "Hình ảnh mẫu 3";
            dataGridView1.Columns[17].HeaderText = "Hình ảnh mẫu 4";
            dataGridView1.Columns[18].HeaderText = "Hình ảnh mẫu 5";
            dataGridView1.Columns[19].HeaderText = "Hình ảnh mẫu 6";
            dataGridView1.Columns[20].HeaderText = "Hình ảnh mẫu 7";
            dataGridView1.Columns[21].HeaderText = "Hình ảnh mẫu 8";
            dataGridView1.Columns[22].HeaderText = "Cân nặng";
            dataGridView1.Columns[23].HeaderText = "Chiều dài";
            dataGridView1.Columns[24].HeaderText = "Chiều rộng";
            dataGridView1.Columns[25].HeaderText = "Chiều cao";
            dataGridView1.Columns[26].HeaderText = "Giao Hàng Nhanh";
            dataGridView1.Columns[27].HeaderText = "J&T Express";
            dataGridView1.Columns[28].HeaderText = "Ninja Van";
            dataGridView1.Columns[29].HeaderText = "BEST Express";
            dataGridView1.Columns[30].HeaderText = "Viettel Post";
            dataGridView1.Columns[31].HeaderText = "Giao Hàng Tiết Kiệm";
            dataGridView1.Columns[32].HeaderText = "VNPost Tiết Kiệm";
            dataGridView1.Columns[33].HeaderText = "VNPost Nhanh";
            dataGridView1.Columns[34].HeaderText = "Ngày chuẩn bị hàng";
        }

        public void export2Excel(DataGridView g, string duongDan, string tenTap)
        {
            app obj = new app();
            obj.Application.Workbooks.Add(Type.Missing);
            obj.Columns.ColumnWidth = 50;
            for (int i = 1; i < g.Columns.Count + 1; i++) { obj.Cells[1, i] = g.Columns[i - 1].HeaderText; }
            for (int i = 0; i < g.Rows.Count; i++)
            {
                for (int j = 0; j < g.Columns.Count; j++)
                {
                    if (g.Rows[i].Cells[j].Value != null) { obj.Cells[i + 2, j + 1] = g.Rows[i].Cells[j].Value.ToString(); }
                }
            }
            obj.ActiveWorkbook.SaveCopyAs(duongDan + tenTap + ".xlsx");
            obj.ActiveWorkbook.Saved = true;
            MessageBox.Show("Thành công! \n" + "Đã lưu ở ổ D", "Thông báo");
        }

        public void saveimage(string imageUrl, string saveLocation)
        {
            byte[] imageBytes;
            HttpWebRequest imageRequest = (HttpWebRequest)WebRequest.Create(imageUrl);
            WebResponse imageResponse = imageRequest.GetResponse();

            Stream responseStream = imageResponse.GetResponseStream();

            using (BinaryReader br = new BinaryReader(responseStream))
            {
                imageBytes = br.ReadBytes(500000);
                br.Close();
            }
            responseStream.Close();
            imageResponse.Close();

            FileStream fs = new FileStream(saveLocation, FileMode.Create);
            BinaryWriter bw = new BinaryWriter(fs);
            try
            {
                bw.Write(imageBytes);
            }
            finally
            {
                fs.Close();
                bw.Close();
            }
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (checkedListBox1.CheckedItems.Count == 1)
            {
                foreach (var item in checkedListBox1.CheckedItems)
                {
                    for (int j = 0; j < count; j++)
                    {
                        if (item == nameShopCollection[j])
                        {
                            shopCollection = numbShopCollection[j];
                            nameShop = nameShopCollection[j];
                            countItem = countItemShopCollection[j];
                        }
                    }
                }
            }
            else
                MessageBox.Show("Xin mời chọn lại danh mục sản phẩm", "Thông báo");

            string locateSave = @"D:/Shopee" + nameShop + DateTime.Now.ToString("dd.MM.yyyy.hh.mm.ss");
            if (!Directory.Exists(locateSave))
            {
                Directory.CreateDirectory(locateSave);
            }
            progressBar1.Minimum = 0;
            progressBar1.Maximum = Int32.Parse(countItem);
            MessageBox.Show("Số sản phẩm : " + countItem, "Thông báo");
            for (double x = 0; x < Int64.Parse(countItem); x = x + 100)
            {
                using (HttpRequest requests = new HttpRequest())
                {
                    requests.UserAgent = Http.ChromeUserAgent();
                    string getShopCollectionItemUrl = "https://shopee.vn/api/v2/search_items/?by=relevancy&limit=100&match_id=" + textBox1.Text + "&newest=" + x + "&order=desc&page_type=shop&shop_categoryids=" + shopCollection + "&version=2";
                    string responseShopCollectionItem = requests.Get(getShopCollectionItemUrl).ToString();
                    JObject objShopCollectionItem = JObject.Parse(responseShopCollectionItem);
                    JArray itemShopCollection = (JArray)objShopCollectionItem["items"];

                    for (int i = 0; i < itemShopCollection.Count; i++)
                    {
                        string detail_item_url = "https://shopee.vn/api/v2/item/get?itemid=" + (string)itemShopCollection[i]["itemid"] + "&shopid=" + (string)itemShopCollection[i]["shopid"];
                        string detail_item_json = requests.Get(detail_item_url).ToString();
                        JObject objDetailItem = JObject.Parse(detail_item_json);
                        JArray img = (JArray)objDetailItem["item"]["images"];
                        double price = Int64.Parse((string)objDetailItem["item"]["price"]) / 100000;
                        string[] dataIMG = new string[9];
                        dataIMG[0] = "https://cf.shopee.vn/file/" + (string)objDetailItem["item"]["image"];
                        for (int n = 0; n < img.Count; n++)
                        {
                            dataIMG[n + 1] = "https://cf.shopee.vn/file/" + (string)objDetailItem["item"]["images"][n];
                        }

                        dataGridView1.Rows.Add((string)objDetailItem["item"]["categories"][2]["catid"], (string)objDetailItem["item"]["name"], (string)objDetailItem["item"]["description"], "", "masp", "", "", "", "", "", price, (string)objDetailItem["item"]["normal_stock"], "", dataIMG[0], dataIMG[1], dataIMG[2], dataIMG[3], dataIMG[4], dataIMG[5], dataIMG[6], dataIMG[7], dataIMG[8], "450", "", "", "", "Tắt", "Tắt", "Tắt", "Tắt", "Tắt", "Tắt", "Tắt", "Tắt", "");

                        progressBar1.Value = i + 1 + Convert.ToInt32(x);
                        for (int j = 0; j < img.Count; j++)
                        {
                            string imgUrl = "https://cf.shopee.vn/file/" + (string)objDetailItem["item"]["images"][j];

                            string name = (string)objDetailItem["item"]["name"];
                            string name2 = name.Replace(":", "").Replace("|", "").Replace("{", "").Replace("}", "").Replace("[", "").Replace("]", "").Replace("*", "").Replace("/", "");

                            string locate = locateSave + "/" + name2;
                            if (!Directory.Exists(locate))
                            {
                                Directory.CreateDirectory(locate);
                            }
                            string localImg = @locate + "/" + j + ".jpg";
                            saveimage(imgUrl, localImg);
                        }
                    }
                }
            }
        }

        private void button3_Click(object sender, EventArgs e)
        {
            dataGridView1.Rows.Clear();
            checkedListBox1.Items.Clear();
            progressBar1.Value = 0;
            return;
        }

        private void button4_Click(object sender, EventArgs e)
        {
            export2Excel(dataGridView1, @"D:\", "reportShopee" + DateTime.Now.ToString("dd.MM.yyyy.hh.mm.ss"));
        }

        private void btn_done_Click(object sender, EventArgs e)
        {
            //txt_price.Text = dataGridView1.Rows[3].Cells[10].Value.ToString();
            for (int i = 0; i < dataGridView1.Rows.Count - 1; i++)
            {
                if (txtReplaceAfter.Text != "" || txtReplaceBefore.Text != "")
                {
                    if(txtReplaceAfter.Lines.Length == txtReplaceBefore.Lines.Length)
                    {
                        for (int j = 0; j < txtReplaceBefore.Lines.Length; j++)
                        {
                            dataGridView1.Rows[i].Cells[2].Value = (dataGridView1.Rows[i].Cells[2].Value.ToString().Replace(txtReplaceBefore.Lines[j].ToString(), txtReplaceAfter.Lines[j].ToString())).ToString();
                        }
                    }
                }
                if (txt_maspText.Text != "" || txt_maspNumb.Text != "")
                {
                    dataGridView1.Rows[i].Cells[4].Value = txt_maspText.Text + (Convert.ToInt32(txt_maspNumb.Text) + i).ToString();
                }
                if (txt_price.Text != "")
                {
                    foreach (var checkedprice in checkedListBox_price.CheckedItems)
                    {
                        if (checkedprice.ToString() == "Tăng")
                        {
                            dataGridView1.Rows[i].Cells[10].Value = (Int32.Parse(dataGridView1.Rows[i].Cells[10].Value.ToString()) + Convert.ToInt32(txt_price.Text)).ToString();

                        }
                        else if (checkedprice.ToString() == "Giảm")
                        {
                            dataGridView1.Rows[i].Cells[10].Value = (Int32.Parse(dataGridView1.Rows[i].Cells[10].Value.ToString()) - Convert.ToInt32(txt_price.Text)).ToString();
                        }
                    }
                }
                if (txt_stock.Text != "")
                {
                    foreach (var checkedstock in checkedListBox_stock.CheckedItems)
                    {
                        if (checkedstock.ToString() == "Tăng")
                        {
                            dataGridView1.Rows[i].Cells[11].Value = (Int32.Parse(dataGridView1.Rows[i].Cells[11].Value.ToString()) + Convert.ToInt32(txt_stock.Text)).ToString();

                        }
                        else if (checkedstock.ToString() == "Giảm")
                        {
                            dataGridView1.Rows[i].Cells[11].Value = (Int32.Parse(dataGridView1.Rows[i].Cells[11].Value.ToString()) - Convert.ToInt32(txt_stock.Text)).ToString();
                        }
                    }
                }

                if (txt_maxWeight.Text != "")
                {
                    if (Convert.ToInt32(txt_maxWeight.Text) > 100)
                    {
                        dataGridView1.Rows[i].Cells[22].Value = txt_maxWeight.Text;
                    }

                }

                if(txt_estimatemin.Text != "")
                {
                    if (Convert.ToInt32(txt_estimatemin.Text) > 7 && Convert.ToInt32(txt_estimatemin.Text) < 30)
                    {
                        dataGridView1.Rows[i].Cells[34].Value = txt_estimatemin.Text;
                    }

                }

                foreach (var checkedship in checkedListBox_ship.CheckedItems)
                {
                    if (checkedship.ToString() == "Giao Hàng Nhanh")
                    {
                        dataGridView1.Rows[i].Cells[26].Value = "Mở";
                    }
                    else if (checkedship.ToString() == "J&T Express")
                    {
                        dataGridView1.Rows[i].Cells[27].Value = "Mở";
                    }
                    else if (checkedship.ToString() == "Ninja Van")
                    {
                        dataGridView1.Rows[i].Cells[28].Value = "Mở";
                    }
                    else if (checkedship.ToString() == "BEST Express")
                    {
                        dataGridView1.Rows[i].Cells[29].Value = "Mở";
                    }
                    else if (checkedship.ToString() == "Viettel Post")
                    {
                        dataGridView1.Rows[i].Cells[30].Value = "Mở";
                    }
                    else if (checkedship.ToString() == "Giao Hàng Tiết Kiệm")
                    {
                        dataGridView1.Rows[i].Cells[31].Value = "Mở";
                    }
                    else if (checkedship.ToString() == "VNPost Tiết Kiệm")
                    {
                        dataGridView1.Rows[i].Cells[32].Value = "Mở";
                    }
                    else if (checkedship.ToString() == "VNPost Nhanh")
                    {
                        dataGridView1.Rows[i].Cells[33].Value = "Mở";
                    }
                }               
            }
            MessageBox.Show("Tùy biến thành công", "Thông báo");
        }

        public void button1_Click(object sender, EventArgs e)
        {
            using (HttpRequest requests = new HttpRequest())
            {
                requests.UserAgent = Http.ChromeUserAgent();
                string getShopCollectionUrl = "https://shopee.vn/api/v2/shop/get_categories?limit=20&offset=0&shopid=" + textBox1.Text;

                string responseShopCollection = requests.Get(getShopCollectionUrl).ToString();
                JObject objShopCollection = JObject.Parse(responseShopCollection);
                JArray idShopCollection = (JArray)objShopCollection["data"]["items"];
                progressBar1.Minimum = 0;
                progressBar1.Maximum = idShopCollection.Count;
                count = idShopCollection.Count;
                for (int i = 0; i < idShopCollection.Count; i++)
                {
                    checkedListBox1.Items.Add((string)idShopCollection[i]["name"]);
                    nameShopCollection[i] = (string)idShopCollection[i]["name"];
                    numbShopCollection[i] = (string)idShopCollection[i]["shop_collection_id"];
                    countItemShopCollection[i] = (string)idShopCollection[i]["total_count"];
                    progressBar1.Value = i + 1;
                }
                MessageBox.Show("Lấy danh sách thành công", "Thông báo");
                progressBar1.Value = 0;
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {           
            if (checkedListBox1.CheckedItems.Count == 1)
            {
                foreach (var item in checkedListBox1.CheckedItems)
                {
                    for (int j = 0; j < count; j++)
                    {
                        if (item == nameShopCollection[j])
                        {
                            shopCollection = numbShopCollection[j];
                            nameShop = nameShopCollection[j];
                            countItem = countItemShopCollection[j];
                        }
                    }
                }
            }
            else
                MessageBox.Show("Xin mời chọn lại danh mục sản phẩm", "Thông báo");
            progressBar1.Minimum = 0;
            progressBar1.Maximum = Int32.Parse(countItem);
            MessageBox.Show("Số sản phẩm : " + countItem, "Thông báo");
            for (double x = 0; x < Int64.Parse(countItem); x = x+100)
            {
                using (HttpRequest requests = new HttpRequest())
                {
                    requests.UserAgent = Http.ChromeUserAgent();
                    string getShopCollectionItemUrl = "https://shopee.vn/api/v2/search_items/?by=relevancy&limit=100&match_id=" + textBox1.Text + "&newest=" + x + "&order=desc&page_type=shop&shop_categoryids=" + shopCollection + "&version=2";
                    string responseShopCollectionItem = requests.Get(getShopCollectionItemUrl).ToString();
                    JObject objShopCollectionItem = JObject.Parse(responseShopCollectionItem);
                    JArray itemShopCollection = (JArray)objShopCollectionItem["items"];

                    for (int i = 0; i < itemShopCollection.Count; i++)
                    {
                        string detail_item_url = "https://shopee.vn/api/v2/item/get?itemid=" + (string)itemShopCollection[i]["itemid"] + "&shopid=" + (string)itemShopCollection[i]["shopid"];
                        string detail_item_json = requests.Get(detail_item_url).ToString();
                        JObject objDetailItem = JObject.Parse(detail_item_json);
                        JArray img = (JArray)objDetailItem["item"]["images"];
                        double price = Int64.Parse((string)objDetailItem["item"]["price"]) / 100000;
                        string[] dataIMG = new string[15];
                        dataIMG[0] = "https://cf.shopee.vn/file/" + (string)objDetailItem["item"]["image"];
                        for(int n = 0; n < img.Count; n++)
                        {
                            dataIMG[n+1] = "https://cf.shopee.vn/file/" + (string)objDetailItem["item"]["images"][n];
                        }
                        dataGridView1.Rows.Add((string)objDetailItem["item"]["categories"][2]["catid"], (string)objDetailItem["item"]["name"], (string)objDetailItem["item"]["description"], "", "masp", "", "", "", "", "", price, (string)objDetailItem["item"]["normal_stock"],"", dataIMG[0], dataIMG[1], dataIMG[2], dataIMG[3], dataIMG[4], dataIMG[5], dataIMG[6], dataIMG[7], dataIMG[8], "450", "", "", "", "Tắt", "Tắt", "Tắt", "Tắt", "Tắt", "Tắt", "Tắt", "Tắt", "");                      
                        progressBar1.Value = i + 1 + Convert.ToInt32(x);    
                        if(progressBar1.Value == Int32.Parse(countItem))
                        {
                            MessageBox.Show("Hoàn thành", "Thông báo");
                        }                       
                    }
                }
            }
        }
    }
}
